# -*- coding: utf-8 -*-
from setuphelpers import *


# Declaring global variables - Warnings: 1) WAPT context is only available in package functions; 2) Global variables are not persistent between calls
bin_contains = "smartmontools"
bin_path = makepath(programfiles, "smartmontools", "bin", "smartctl.exe")


def install():
    # Declaring local variables
    package_version = control.get_software_version()
    bin_name = glob.glob("*%s*.exe" % bin_contains)[0]

    def get_version_bin(key):
        return get_file_properties(bin_path)["ProductVersion"]

    # uninstalling older versions of the package
    if package_version > get_version_bin("test") or not isdir(makepath(programfiles, "smartmontools")):
        for to_uninstall in installed_softwares(bin_contains):
            print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
            killalltasks(control.impacted_process.split(","))
            run(uninstall_cmd(to_uninstall["key"]))
            wait_uninstallkey_absent(to_uninstall["key"])

    # Installing the software
    print("Installing: %s" % bin_name)
    # print("Installing: %s (%s)" % (bin_name, package_version))
    # print("Installing: %s (%s)" % (control.name, package_version))
    install_exe_if_needed(
        bin_name,
        silentflags="/S",
        key="smartmontools",
        min_version=package_version,
        get_version=get_version_bin,
    )
